# DGS2

from math import *
from SWGui import *
initSWGui()

buttonFrame=SWFrameHori() # Ein Container fuer die Buttons
bZug=SWButton(container=buttonFrame,text="Zugmodus")
bPunkt=SWButton(container=buttonFrame,text="Punkt")
bMP=SWButton(container=buttonFrame,text="MP")
bSchnitt=SWButton(container=buttonFrame,text="Schnittpunkt")
bGerade=SWButton(container=buttonFrame,text="Gerade")
bLot=SWButton(container=buttonFrame,text="Lot")
bParallele=SWButton(container=buttonFrame,text="Parallele")
bKreis=SWButton(container=buttonFrame,text="Kreis")
message=SWLabel(container=buttonFrame,text="")
message.setWidth(22)

zeichenflaeche=SWCanvas(width=400,height=400)

modus="Punkt"   # Jeweils aktueller Modus des Programms
operanden=[]    # Liste von Operanden der aktuellen Operation

def setMode(m,hilfetext):
    global modus,message,operanden 
    modus=m
    message.setText(hilfetext)
    operanden=[]
    
def zugModus(): setMode("Zug","Zugmodus")
def punktModus():setMode("Punkt","Punkt erzeugen")
def MPModus(): setMode("MP","Mittelpunkt")
def schnittModus(): setMode("Schnitt","Schnittpunkt")
def geradeModus(): setMode("Gerade","Gerade")
def lotModus(): setMode("Lot","Lot")
def paralleleModus(): setMode("Parallele","Parallele")
def kreisModus(): setMode("Kreis","Kreis")
bZug.setCommand(zugModus)  # Buttons mit Funktion versehen
bPunkt.setCommand(punktModus)
bMP.setCommand(MPModus)
bSchnitt.setCommand(schnittModus)
bGerade.setCommand(geradeModus)
bLot.setCommand(lotModus)
bParallele.setCommand(paralleleModus)
bKreis.setCommand(kreisModus)

# Hilfsfunktionen, die zwischen mathematischen Koordinaten
# und Bildschirm-Koordinaten umrechnen

ausschnitt={"xmin":-10.0,"xmax":10.0,"ymin":-10.0,"ymax":10.0}

def welt2schirm(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xw,yw]=co
    [w,h]=zeichenflaeche.getDim()
    sc=[w*(xw-a["xmin"])/(a["xmax"]-a["xmin"]),
        h*(1-(yw-a["ymin"])/(a["ymax"]-a["ymin"]))]
    return map(int,sc)

def schirm2welt(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xs,ys]=co
    [w,h]=zeichenflaeche.getDim()
    return [a["xmin"]+(a["xmax"]-a["xmin"])*xs/float(w),
            a["ymin"]+(a["ymax"]-a["ymin"])*(1-ys/float(h))]

def klick(event):
    global modus,operanden
    co=schirm2welt([event.x,event.y])
    print "Klick bei ", co
    if modus=="Punkt": erzeugePunkt(co)
    else:
        obj=getroffen(co)
        if obj==None: return
        print "Klick trifft: ", obj["name"]
        operanden.append(obj)
        if modus=="MP" and len(operanden)==2:
            erzeugeMittelpunkt(operanden)
            operanden=[]

def drag(event):
    co=schirm2welt([event.x,event.y])
    print "Drag nach ", co
    if modus=="Zug":
        if len(operanden)==0: return # Kein Objekt ausgewaehlt
        moveTo(operanden[-1],co) # Das zu letzt bewegte Objekt wird bewegt

def loslassen(event):
    global modus,operanden
    if modus=="Zug": operanden=[]

zeichenflaeche.setClickCommand(klick)
zeichenflaeche.setReleaseCommand(loslassen)
zeichenflaeche.setDragCommand(drag)

# --- Routinen zur Behandlung der geometrischen Objekte

objekte=[] # Liste aller Objekte

def getroffen(co): # Gibt None oder Objekt, das nahe bei co liegt
    global objekte,ausschnitt
    diag=sqrt((ausschnitt["xmax"]-ausschnitt["xmin"])**2+
              (ausschnitt["xmax"]-ausschnitt["xmin"])**2)
    mindist=1e10
    obj=None
    for a in objekte:
        d=-1
        if a["typ"]=="Punkt": d=sqrt((co[0]-a["x"])**2+(co[1]-a["y"])**2)
        if d==-1: continue # Es konnte ein Abstand berechnet werden
        if d<mindist:
            mindist=d
            obj=a
    if mindist>diag/100.0: return None # Abstand zu gross
    return obj

Pzaehler,Gzaehler,Kzaehler=0,0,0
def punktName():
    global Pzaehler
    Pzaehler=Pzaehler+1
    return "P"+str(Pzaehler)
def geradeName():
    global Gzaehler
    Gzaehler=Gzaehler+1
    return "G"+str(Gzaehler)
def kreisName():
    global Kzaehler
    Kzaehler=Kzaehler+1
    return "K"+str(Kzaehler)

def erzeugePunkt(co): # Co ist Liste von Weltkoordinaten
    global zeichenflaeche,objekte
    [xs,ys]=welt2schirm(co)
    P={"x":co[0], "y":co[1], "name":punktName()}
    # P ist Dictionary mit allen Informationen 
    GUIpunkt=zeichenflaeche.createCircle(xs,ys,5)
    GUIpunkt.setColor("red")
    P["gui"]=GUIpunkt
    P["label"]=zeichenflaeche.createText(xs+15,ys,P["name"])
    P["typ"]="Punkt"
    P["untertyp"]=""
    P["frei"]=True # Ist der Punkt frei ziehbar?
    P["kinder"]=[]
    P["eltern"]=[]
    objekte.append(P)

def erzeugeMittelpunkt(ops):
    global zeichenflaeche,objekte
    [A,B]=ops
    co=[ (A["x"]+B["x"])/2.0, (A["y"]+B["y"])/2.0 ]
    [xs,ys]=welt2schirm(co)
    P={"x":co[0], "y":co[1], "name":punktName()}
    # P ist Dictionary mit allen Informationen 
    GUIpunkt=zeichenflaeche.createCircle(xs,ys,5)
    GUIpunkt.setColor("blue")
    P["gui"]=GUIpunkt
    P["label"]=zeichenflaeche.createText(xs+15,ys,P["name"])
    P["typ"]="Punkt"
    P["untertyp"]="Mittelpunkt"
    P["frei"]=False # Ist der Punkt frei ziehbar?
    P["kinder"]=[]
    P["eltern"]=ops
    objekte.append(P)
    A["kinder"].append(P)
    B["kinder"].append(P)
    
def moveTo(obj,co): # Bewegt das Objekt obj nach co
    if obj["typ"]<>"Punkt": return # Nur Punkte koennen gezogen werden
    if obj["frei"]:
        [obj["x"],obj["y"]]=co
        [sx,sy]=welt2schirm(co)
        obj["gui"].setCenter(sx,sy)
        obj["label"].setCoords([sx+15,sy])
        for kind in obj["kinder"]: update(kind)

def update(obj): # Eltern haben sich bewegt, jetzt aktualisieren
    if obj["typ"]=="Punkt" and obj["untertyp"]=="Mittelpunkt":
        [A,B]=obj["eltern"]
        co=[ (A["x"]+B["x"])/2.0, (A["y"]+B["y"])/2.0 ]
        [obj["x"],obj["y"]]=co
        [sx,sy]=welt2schirm(co)
        obj["gui"].setCenter(sx,sy)
        obj["label"].setCoords([sx+15,sy])
    for kind in obj["kinder"]: update(kind)
    


