# DGS3

from math import *
from SWGui import *
initSWGui()

buttonFrame=SWFrameHori() # Ein Container fuer die Buttons
bZug=SWButton(container=buttonFrame,text="Zugmodus")
bPunkt=SWButton(container=buttonFrame,text="Punkt")
bMP=SWButton(container=buttonFrame,text="MP")
bSchnitt=SWButton(container=buttonFrame,text="Schnittpunkt")
bGerade=SWButton(container=buttonFrame,text="Gerade")
bLot=SWButton(container=buttonFrame,text="Lot")
bParallele=SWButton(container=buttonFrame,text="Parallele")
bKreis=SWButton(container=buttonFrame,text="Kreis")
message=SWLabel(container=buttonFrame,text="")
message.setWidth(22)

zeichenflaeche=SWCanvas(width=400,height=400)

modus="Punkt"   # Jeweils aktueller Modus des Programms
operanden=[]    # Liste von Operanden der aktuellen Operation

def setMode(m,hilfetext):
    global modus,message,operanden 
    modus=m
    message.setText(hilfetext)
    operanden=[]
    
def zugModus(): setMode("Zug","Zugmodus")
def punktModus():setMode("Punkt","Punkt erzeugen")
def MPModus(): setMode("MP","Mittelpunkt")
def schnittModus(): setMode("Schnitt","Schnittpunkt")
def geradeModus(): setMode("Gerade","Gerade")
def lotModus(): setMode("Lot","Lot")
def paralleleModus(): setMode("Parallele","Parallele")
def kreisModus(): setMode("Kreis","Kreis")
bZug.setCommand(zugModus)  # Buttons mit Funktion versehen
bPunkt.setCommand(punktModus)
bMP.setCommand(MPModus)
bSchnitt.setCommand(schnittModus)
bGerade.setCommand(geradeModus)
bLot.setCommand(lotModus)
bParallele.setCommand(paralleleModus)
bKreis.setCommand(kreisModus)

# Hilfsfunktionen, die zwischen mathematischen Koordinaten
# und Bildschirm-Koordinaten umrechnen

ausschnitt={"xmin":-10.0,"xmax":10.0,"ymin":-10.0,"ymax":10.0}

def diag(): # Schirmdiagonale
    global ausschnitt
    return sqrt((ausschnitt["xmax"]-ausschnitt["xmin"])**2+
              (ausschnitt["xmax"]-ausschnitt["xmin"])**2)

def welt2schirm(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xw,yw]=co
    [w,h]=zeichenflaeche.getDim()
    sc=[w*(xw-a["xmin"])/(a["xmax"]-a["xmin"]),
        h*(1-(yw-a["ymin"])/(a["ymax"]-a["ymin"]))]
    return map(int,sc)

def schirm2welt(co):
    global ausschnitt,zeichenflaeche
    a=ausschnitt
    [xs,ys]=co
    [w,h]=zeichenflaeche.getDim()
    return [a["xmin"]+(a["xmax"]-a["xmin"])*xs/float(w),
            a["ymin"]+(a["ymax"]-a["ymin"])*(1-ys/float(h))]

def klick(event):
    global modus,operanden
    co=schirm2welt([event.x,event.y])
    print "Klick bei ", co
    if modus=="Punkt": erzeugePunkt(co)
    else:
        obj=getroffen(co)
        if obj==None: return
        print "Klick trifft: ", obj["name"]
        operanden.append(obj)
        if modus=="MP" and len(operanden)==2:
            erzeugeMittelpunkt(operanden)
            operanden=[]

def drag(event):
    co=schirm2welt([event.x,event.y])
    print "Drag nach ", co
    if modus=="Zug":
        if len(operanden)==0: return # Kein Objekt ausgewaehlt
        call(operanden[-1],"moveTo",co) # Das zu letzt bewegte Objekt wird bewegt

def loslassen(event):
    global modus,operanden
    if modus=="Zug": operanden=[]

zeichenflaeche.setClickCommand(klick)
zeichenflaeche.setReleaseCommand(loslassen)
zeichenflaeche.setDragCommand(drag)

# --- Routinen zur Behandlung der geometrischen Objekte

objekte=[] # Liste aller Objekte

def getroffen(co): # Gibt None oder Objekt, das nahe bei co liegt
    global objekte
    for a in objekte:
        if call(a,"getroffen",co): return a
    return None

Pzaehler,Gzaehler,Kzaehler=0,0,0
def punktName():
    global Pzaehler
    Pzaehler=Pzaehler+1
    return "P"+str(Pzaehler)
def geradeName():
    global Gzaehler
    Gzaehler=Gzaehler+1
    return "G"+str(Gzaehler)
def kreisName():
    global Kzaehler
    Kzaehler=Kzaehler+1
    return "K"+str(Kzaehler)

# Jetzt kommt ein ad hoc Klassensystem mit Vererbung
# Objekte sind Dictionaries, mit einer Methodentabelle

def call(obj,methname,*args): # Methodenaufruf
    alleArgs=[obj]+list(args)           # Das ist Liste [obj,arg1,arg2,..]
    methode=obj["methoden"][methname]   # Das ist die Methoden-Funktion
    return apply(methode, alleArgs)

def erzeugeGeoObj(): # Allgemeines Geo.Objekt
    global objekte
    P={"name":"?"}
    # P ist Dictionary mit allen Informationen 
    P["gui"]=None
    P["label"]=zeichenflaeche.createText(-10,-10,P["name"])
    P["Klasse"]="GeoObj"
    P["frei"]=False # Ist das Objekt ziehbar?
    P["kinder"]=[]
    P["eltern"]=[]
    def update0(mich):
        pass # Dummy-Methode: Sich selbst aktualisieren
    def update(mich):
        call(mich,"update0")
        for kind in mich["kinder"]: call(kind,"update")
    P["methoden"]={"update":update,"update0":update0}
    objekte.append(P)
    return P

def erzeugePunkt(co): # Co ist Liste von Weltkoordinaten
    global zeichenflaeche,objekte
    P=erzeugeGeoObj()
    P["name"]=punktName()
    P["frei"]=True # Ist das Objekt ziehbar?
    [P["x"],P["y"]]=co
    P["gui"]=zeichenflaeche.createCircle(-10,-10,5)
    P["gui"].setColor("red")
    def update0(mich):
        [sx,sy]=welt2schirm([mich["x"],mich["y"]])
        mich["gui"].setCenter(sx,sy)
        mich["label"].setCoords([sx+15,sy])
        mich["label"].setText(mich["name"])
    update0(P)
    P["methoden"]["update0"]=update0
    def getroffen(ich,co):
        return sqrt((co[0]-ich["x"])**2+(co[1]-ich["y"])**2)<diag()/100.0
    P["methoden"]["getroffen"]=getroffen
    def moveTo(ich,co):
        [ich["x"],ich["y"]]=co
        call(ich,"update")
    P["methoden"]["moveTo"]=moveTo            
    return P
    

def erzeugeMittelpunkt(ops):
    global zeichenflaeche,objekte
    [A,B]=ops
    P=erzeugePunkt([1.0,2.0]) # Koordinaten erstmal unwichtig
    A["kinder"].append(P)
    B["kinder"].append(P)
    P["eltern"]=ops
    P["frei"]=False
    P["gui"].setColor("blue")
    def update0(mich):
        A=mich["eltern"][0]
        B=mich["eltern"][1]
        co=[ (A["x"]+B["x"])/2.0, (A["y"]+B["y"])/2.0 ]
        [xs,ys]=welt2schirm(co)
        [mich["x"],mich["y"]]=co 
        [sx,sy]=welt2schirm([mich["x"],mich["y"]])
        mich["gui"].setCenter(sx,sy)
        mich["label"].setCoords([sx+15,sy])
        mich["label"].setText(mich["name"])
    update0(P)
    def moveTo(ich,co):
        pass
    P["methoden"]["update0"]=update0
    P["methoden"]["moveTo"]=moveTo
    return P
        


