# Weg 1: OO mit Listen

import math

a=["Punkt",14.5,1.2,20]
b=["Punkt",-4,2,3]
f=["Farbe",10,10,255]
g=["Farbe",255,255,255]

def typ(a): return a[0]

def Betrag(A):
    if typ(A)=="Punkt": return math.sqrt(A[1]**2+A[2]**2+A[3]**2)
    if typ(A)=="Farbe": return A[1]+A[2]+A[3]
    print "Fehler: Falsche Datentypen in Betrag"

print "Betrag von a=",Betrag(a)
print "Betrag von f=",Betrag(f)


#---------- Konstruktoren einfuehren

def makePunkt(x,y,z): return ["Punkt",x,y,z]
def makeFarbe(r,g,b):
    if r<0 or g<0 or b<0 or r>255 or g>255 or b>255:
        raise Exception("Falsche Farbwerte")
    return ["Farbe",int(r),int(g),int(b)]

c=makePunkt(1,2,3)
h=makeFarbe(255,0,0)


# -------- Methoden in den Konstruktor schreiben
# Hier startet die Datei gewissermssen neu: Man kann alles oberhalb loeschen

def makePunkt(x,y,z):
    A=["Punkt",x,y,z]
    def Betrag(A):
        return math.sqrt(A[1]**2+A[2]**2+A[3]**2)
    def Mittelpunkt(A,B):
        return makePunkt((A[1]+B[1])/2.0,
                         (A[2]+B[2])/2.0,
                         (A[3]+B[3])/2.0)
    def Beschreibe(A):
        return "["+str(A[1])+","+str(A[2])+","+str(A[3])+"]"
    methodenliste=["Betrag",Betrag,
                   "Mittelpunkt",Mittelpunkt,
                   "Beschreibe",Beschreibe]
    return A+[methodenliste]

def call(objekt,methode,*args):
    alleargs=[objekt]+list(args)
    methodenliste=objekt[-1]
    for i in range(len(methodenliste)):
        if methodenliste[i]==methode:
            return apply(methodenliste[i+1],alleargs)
    print "Methode unbekannt"

a=makePunkt(1,2,3)
b=makePunkt(2,0,7)
print "Beschreibe a ", call(a,"Beschreibe")
print "Beschreibe b ", call(b,"Beschreibe")
c=call(a,"Mittelpunkt",b)
print "Mittelpunkt c von a und b", call(c,"Beschreibe")
print "Betrag von c ", call(c,"Betrag")

# Jetzt noch eine Farbklasse ------

def makeFarbe(r,g,b):
    if r<0 or g<0 or b<0 or r>255 or g>255 or b>255:
        raise Exception("Falsche Farbwerte")
    A=["Farbe",int(r),int(g),int(b)]
    def Betrag(A): return A[1]+A[2]+A[3]
    def Beschreibe(A):
        return "Farbe("+str(A[1])+","+str(A[2])+","+str(A[3])+")"
    methodenliste=["Betrag",Betrag,
                   "Beschreibe",Beschreibe]
    return A+[methodenliste]

f=makeFarbe(255,255,0)
print "Beschreibe f ", call(f,"Beschreibe")
print "Betrag von f ", call(f,"Betrag")


# Vererbung: Eine Klasse GeoPunkt erbt von Punkt

def makeGeoPunkt(name,x,y,z,r,g,b):
    A=makePunkt(x,y,z)
    A[0]="GeoPunkt"
    methodenliste=A[-1]
    del A[-1] # Alte Methodenliste wegnehmen
    A.append(makeFarbe(r,g,b))
    A.append(name)
    def Beschreibe(A):
        return "GeoPunkt "+A[5]+"["+str(A[1])+","+str(A[2])+","+str(A[3])+"] Farbe="+call(A[4],"Beschreibe")
    def setzeNamen(A,nam): A[5]=nam
    neuemethodenliste=["Beschreibe",Beschreibe,
                       "setzeNamen",setzeNamen]
    return A+[neuemethodenliste+methodenliste]

gp=makeGeoPunkt("Q",1,2,3,255,0,0)
print 
print call(gp,"Beschreibe")
call(gp,"setzeNamen","Q1")
print call(gp,"Beschreibe")

