# OO prototypisch (R. Oldenburg, oldenbur@math.uni-frankfurt.de)

import copy
import math

# Prototyp erzeugen: Ein Punkt 
Punkt={}
Punkt["x"]=5
Punkt["y"]=10
Punkt["name"]="P1"
Punkt["ist"]="Punkt"  

# Zwei Punkte erzeugen
A=copy.deepcopy(Punkt)
B=copy.deepcopy(Punkt)
[A["x"], A["y"]]=[9,1]  # Zuweisung, koennten auch in so aussehen: A["x"]=9 u.s.w
[B["x"], B["y"]]=[3,3]

def abstandVon(ich,du):
    return math.sqrt((ich["x"]-du["x"])**2+(ich["y"]-du["y"])**2)    
def alsStr(ich): return "["+str(ich["x"])+"|"+str(ich["y"])+"]"
def verschiebe(ich,dx,dy):
    ich["x"]+=dx
    ich["y"]+=dy

methoden={}
methoden["Punkt"]={"abstandVon":abstandVon,
                   "alsStr":alsStr,
                   "verschiebe":verschiebe}

def call(objekt,methodenName,*args):
    global methoden
    klassenName=objekt["ist"]
    methodenListe=methoden[klassenName]
    methode=methodenListe[methodenName]
    return apply(methode,[objekt]+list(args))

print "A=",call(A,"alsStr")
print "B=",call(B,"alsStr")
print "Abstand A,B=",call(A,"abstandVon",B)
print "Jetzte Verschiebung von A um 10, 11"
call(A,"verschiebe",10,11)
print "A=",call(A,"alsStr")
print "Abstand A,B=",call(A,"abstandVon",B)

# Vererbung: Ein Kreis ist ein Punkt, der einen Radius hat

Kreis=copy.deepcopy(Punkt)
Kreis["r"]=5
Kreis["ist"]="Kreis"
methoden["Kreis"]=methoden["Punkt"]
def KreisalsStr(ich):
    return "Kreis["+str(ich["x"])+"|"+str(ich["y"])+";radius="+str(ich["r"])+"]"
methoden["Kreis"]["alsStr"]=KreisalsStr

K1=copy.deepcopy(Kreis)
K2=copy.deepcopy(Kreis)
K1["r"]=10
print
print "K1=", call(K1,"alsStr")


